#include <stdio.h>
#include <stdlib.h>
#include <libintl.h>
# include <sys/types.h>
#include <unistd.h>
#include <errno.h>
#include <langinfo.h>

#define _(String) gettext (String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)

#define TEXTDOMAIN  "my"

int main(int argc, const char * argv[])
{
	pid_t pid;

	printf("LC_CTYPE = %s\n", setlocale(LC_CTYPE, NULL));
	printf("LC_MESSAGES = %s\n", setlocale(LC_MESSAGES, NULL));
	printf("nl_langinfo CODESET = %s\n", nl_langinfo(CODESET));

	setlocale(LC_ALL, "");
	bindtextdomain(TEXTDOMAIN, "./locale");
	textdomain(TEXTDOMAIN);

	pid = fork();
	if (pid < 0)
	{
		fprintf(stderr, "Error fork %d\n", errno);
		exit(EXIT_FAILURE);
	}
	else if (pid == 0)
	{
		bind_textdomain_codeset(TEXTDOMAIN, "utf-8");

		printf("Child LC_CTYPE = %s\n", setlocale(LC_CTYPE, NULL));
		printf("Child LC_MESSAGES = %s\n", setlocale(LC_MESSAGES, NULL));
		printf("Child nl_langinfo CODESET = %s\n", nl_langinfo(CODESET));

		printf(_("This is a sample program %s\n"), "child");
		_exit(0);

	}
	else
	{
		printf("Parent LC_CTYPE = %s\n", setlocale(LC_CTYPE, NULL));
		printf("Parent LC_MESSAGES = %s\n", setlocale(LC_MESSAGES, NULL));
		printf("Parent nl_langinfo CODESET = %s\n", nl_langinfo(CODESET));

		printf(_("This is a sample program %s\n"), "parent");
	}

	return EXIT_SUCCESS;

}
